set logfilename {N:\FOP1\fop-0.93\conf\fntinf.txt}
set fdlog [open $logfilename {RDWR TRUNC CREAT}]

set fdir {N:\FOP1\fop-0.93\fonts}

set fonts [glob -tails -directory $fdir *.ttf]

#-------------------------------------------------------#
set smap [list Book,Oblique italic Bold,Italic italic Demi,Oblique italic Demi,Italic italic Light,Italic italic Bold,Oblique italic BoldItalic italic Light normal Medium normal Bold normal Oblique italic Book normal Demi normal Ultra normal Regular normal Roman normal Italic italic]
set wmap [list Book,Oblique normal Bold,Italic bold Demi,Oblique normal Demi,Italic normal Light,Italic normal Bold,Oblique bold BoldItalic bold Light normal Medium normal Bold bold Oblique normal Book normal Demi normal Ultra normal Regular normal Roman normal Italic normal]
set fdcfg [open {N:\FOP1\fop-0.93\conf\userconfig.xml} {RDWR TRUNC CREAT}]
puts $fdcfg "<configuration>\n  <fonts>"
set dbdir N:\\FOP1\\fop-0.93\\fonts\\
#-------------------------------------------------------#

foreach F $fonts {
    set fontfilename $fdir/$F
    set fdfont [open $fontfilename]
    fconfigure $fdfont -encoding binary -translation binary
    
    
    set MAX 10000
        
    set TMP [read $fdfont 12]
    binary scan $TMP SSSSSS verH verL numTables searchRange entrySelector rangeShift
    
    set idx 12
    
    while {$idx < $MAX} {
#puts -nonewline $fdlog "$idx:\t"
        set TMP [read $fdfont 16]
        binary scan $TMP A4H8H8I tag checkSum offset length
#puts -nonewline $fdlog "$tag[string repeat " " [expr 4 - [string length $tag]]] - 0x$checkSum - 0x$offset - $length"
    
        scan $offset %8x offset
#puts $fdlog "\t; $offset"
        set tbl_${tag}(offset) $offset
        set tbl_${tag}(length) $length
        
        if {$offset < $MAX} {set MAX $offset}
        incr idx 16
    }
#puts $fdlog \n\n


puts $fdlog \n$F    
    seek $fdfont $tbl_name(offset) start
    set TMP [read $fdfont 6]
        binary scan $TMP SSS fmt nrecs offstr
    incr offstr $tbl_name(offset)
    
    set fdtemp [open $fontfilename]

    for {set n 0} {$n < $nrecs} {incr n} {
        set TMP [read $fdfont 12]
        binary scan $TMP SSSSSS pID eID langID nmID len offs
        if {$langID != 1033} {continue}
        if {$nmID > 6} {continue}
puts -nonewline $fdlog "$nmID"
        seek $fdtemp [expr $offstr + $offs] start
        set strtmp [string map [list "\0" ""] [read $fdtemp $len]]
puts $fdlog \t$strtmp
        if {$nmID == 1} {
            set ntmp $strtmp
        } elseif {$nmID == 2} {
            set strtmp [string map [list " " ,] $strtmp]
            set stmp [string map $smap $strtmp]
            set wtmp [string map $wmap $strtmp]
        } elseif {$nmID == 6} {
            set ptmp $strtmp
        }

    }
    close $fdtemp
    close $fdfont

    if {[array exists tbl_kern]} {set K kerning=\"yes\"} {set K kerning=\"no\"}
    puts $fdcfg "    <font metrics-url=\"${dbdir}[file rootname $F].xml\" $K embed-url=\"${dbdir}$F\">"
    puts $fdcfg "      <font-triplet name=\"$ntmp\" style=\"$stmp\" weight=\"$wtmp\"/>"
    puts $fdcfg "      <font-triplet name=\"$ptmp\" style=\"$stmp\" weight=\"$wtmp\"/>"
    puts $fdcfg "    </font>"
}

close $fdlog
puts $fdcfg "  </fonts>\n</configuration>"
close $fdcfg
exit
